# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define parent myfaces
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Summary:        JSF 2.0 API 
Name:           myfaces-core20-api
Version:        2.0.16
Release:        2%{?dist}
Epoch:          0
License:        Apache Software License 2.0
URL:            http://myfaces.apache.org/
Group:          Development/Libraries/Application Frameworks
Source0:        myfaces-core-module-2.0.16.tgz
# svn export http://svn.apache.org/repos/asf/myfaces/core/tags/myfaces-core-module-2.0.16/
# tar czf myfaces-core-module-2.0.16.tgz myfaces-core-module-2.0.16/

Source1:        myfaces-core20-api-jpp-depmap.xml
Source2:        myfaces-core20-api-settings.xml
Source3:        http://repo1.maven.org/maven2/org/apache/myfaces/myfaces/14/myfaces-14.pom

Patch0:         myfaces-core20-api-pom.patch
Patch1:         myfaces-core20-parent-pom.patch
Patch2:         myfaces-core20-api-api-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
#BuildRequires:  maven2-plugin-assembly
#BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
#BuildRequires:  maven2-plugin-install
#BuildRequires:  maven2-plugin-jar
#BuildRequires:  maven2-plugin-javadoc
#BuildRequires:  maven2-plugin-resources
#BuildRequires:  maven2-plugin-source
#BuildRequires:  maven-surefire-plugin
#BuildRequires:  maven-surefire-provider-testng
#BuildRequires:  maven-common-artifact-filters
#BuildRequires:  junit44
#BuildRequires:  mojo-maven2-plugin-cobertura
BuildRequires:  apache-commons-jxpath
BuildRequires:  apache-rat
BuildRequires:  jsunit
BuildRequires:  myfaces-builder-annotations
BuildRequires:  myfaces-builder-plugin
BuildRequires:  myfaces-javascript-plugin
BuildRequires:  myfaces-plugin-parent

BuildRequires:  geronimo-genesis2
BuildRequires:  geronimo-genesis

BuildRequires:  geronimo-el-2.2-api
BuildRequires:  geronimo-jsp-2.1-api
BuildRequires:  geronimo-servlet-2.5-api
BuildRequires:  geronimo-validation-1.0-api

BuildRequires:  oss-parent
BuildRequires:  easymock-classextension2
BuildRequires:  testng
#BuildRequires:  jakarta-taglibs-standard
#BuildRequires:  servlet_2_5_api
#BuildRequires:  jsp_2_1_api
#BuildRequires:  jmock
#BuildRequires:  jsunit
#BuildRequires:  el_1_0_api
#BuildRequires:  apache-commons-logging
#BuildRequires:  apache-commons-beanutils

Requires:  java >= 0:1.6.0
#Requires:  jakarta-taglibs-standard
#Provides:  jsf_2_0_api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
JavaServer(tm) Faces is a new and upcoming web application framework 
that accomplishes the MVC paradigm. It is comparable to the 
well-known Struts Framework but has features and concepts that 
are beyond those of Struts; especially the component orientation. 
Look at Sun's JavaServer(tm) Page to learn more about the Java 
Specification Request 314  and to download the specification. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n myfaces-core-module-%{version}

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/myfaces/myfaces/9/
cp %{SOURCE3} ${MAVEN_REPO_LOCAL}/org/apache/myfaces/myfaces/9/myfaces-9.pom
mkdir -p ${MAVEN_REPO_LOCAL}/org/apache/myfaces/myfaces/14/
cp %{SOURCE3} ${MAVEN_REPO_LOCAL}/org/apache/myfaces/myfaces/14/myfaces-14.pom

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{parent}
install -m 644 api/target/myfaces-api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{parent}/core20-api-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{parent} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
touch $RPM_BUILD_ROOT%{_javadir}/jsf_2_0_api.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-core20.pom
%add_to_maven_depmap org.apache.myfaces.core myfaces-core-project %{version} JPP/%{parent} core20
install -m 644 api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-core20-api.pom
%add_to_maven_depmap org.apache.myfaces.core myfaces-api %{version} JPP/%{parent} core20-api
#install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-master.pom
#%add_to_maven_depmap org.apache.myfaces myfaces 5 JPP/%{parent} master

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr api/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
update-alternatives --install /usr/share/java/jsf_2_0_api.jar jsf_2_0_api \
    /usr/share/java/myfaces/core20-api.jar 20000

%postun
%update_maven_depmap
if [ "$1" = "0" ]; then
    update-alternatives --remove jsf_2_0_api \
        /usr/share/java/myfaces/core20-api.jar
fi

%files
%defattr(0644,root,root,0755)
%doc assembly/src/main/resources/LICENSE.txt
%ghost %{_javadir}/*.jar
%{_javadir}/%{parent}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Tue Feb 05 2013 Ralph Apel <r.apel@r-apel.de> - 0:2.0.16-2
- Prevent xzpayload problem

* Sun Jan 13 2013 Ralph Apel <r.apel@r-apel.de> - 0:2.0.16-1
- 2.0 api

* Tue Sep 14 2010 Ralph Apel <r.apel@r-apel.de> - 0:1.2.3-2
- Add myfaces-master-5.pom

* Thu May 21 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.2.3-1.jpp5
- 1.2.3 as myfaces-core12-api

* Wed Mar 11 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.5-1.jpp5
- 1.1.5 as myfaces-core11-api

* Mon Mar 13 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.1.0-3jpp
- New name for dependency: easymock-classextension

* Mon Jan 02 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.1.0-2jpp
- Rebuild into JPP 1.7
- Add missing requires for jsp

* Tue Oct 18 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.1.0-1jpp
- First JPackage build

